<template>
  <b-nav-item-dropdown
    class="dropdown-notification mr-25"
    menu-class="dropdown-menu-media"
    right
  >
    <template #button-content>
      <feather-icon
        :badge="notReadedNotifications"
        badge-classes="bg-danger"
        class="text-body"
        icon="BellIcon"
        size="21"
      />
    </template>

    <!-- Header -->
    <li class="dropdown-menu-header">
      <div class="dropdown-header d-flex">
        <h4 class="notification-title mb-0 mr-auto">
          Notificaciones
        </h4>
        <b-badge
          pill
          variant="light-primary"
        >
          {{notifications.length}}
        </b-badge>
      </div>
    </li>

    <!-- Notifications -->
    <vue-perfect-scrollbar
      :settings="perfectScrollbarSettings"
      class="scrollable-container media-list scroll-area"
      tagname="li"
    >
      <!-- Account Notification -->
      <b-link
        v-for="notification in notifications"
        :key="notification.id"
      >
        <b-media @click="readNotification(notification.id)">
          <template #aside>
            <b-avatar
              size="32"
             
            />
          </template>
          <p class="media-heading">
            <span class="font-weight-bolder" v-if="!notification.readed">
              {{ notification.title }}
            </span>
            <span v-else>{{ notification.title }}</span>
          </p>
          <small class="notification-text">{{ notification.description }}</small>
        </b-media>
      </b-link>

     
    </vue-perfect-scrollbar>

    <!-- Cart Footer -->
    <li class="dropdown-menu-footer"><b-button
      v-ripple.400="'rgba(255, 255, 255, 0.15)'"
      variant="primary"
      block
      @click="readNotifications"
    >Leer todas las notificaciones</b-button>
    </li>
  </b-nav-item-dropdown>
</template>

<script>
import {
  BNavItemDropdown, BBadge, BMedia, BLink, BAvatar, BButton, BFormCheckbox,
} from 'bootstrap-vue'
import VuePerfectScrollbar from 'vue-perfect-scrollbar'
import Ripple from 'vue-ripple-directive'

export default {
  components: {
    BNavItemDropdown,
    BBadge,
    BMedia,
    BLink,
    BAvatar,
    VuePerfectScrollbar,
    BButton,
    BFormCheckbox,
  },
  directives: {
    Ripple,
  },
  data(){
    return{
      notifications:[],
      perfectScrollbarSettings:{
        maxScrollbarLength: 60,
        wheelPropagation: false,
      },
      notReadedNotifications:0
    }
  },
  methods:{
    getNotifications(){
      let userData = JSON.parse(localStorage.userData)
      this.$http.get('user/notifications',{params:{user:userData.id}}).then(res=>{
        this.notifications = res.data.notifications
        this.notReadedNotifications = this.notifications.filter( (currentValue) => currentValue.readed === 0).length
      })
    },
    readNotifications(){
      let notifications = []
      for(let i = 0;i < this.notifications.length; i++){
        if(this.notifications[i].readed === 0){
          notifications.push(this.notifications[i].id)
        }
      }
      this.$http.get('user/notifications/read',{params:{notifications:notifications}}).then(res=>{
        this.getNotifications()
      })
    },
    readNotification(index){
      let notifications = []
      notifications.push(index)
      this.$http.get('user/notifications/read',{params:{notifications:notifications}}).then(res=>{
        this.getNotifications()
      })
  },
  },
  
  mounted(){
    this.getNotifications()
  },

  
}
</script>

<style>

</style>
